<?php 
require_once "../modelos/Controlvisita.php";
if (strlen(session_id())<1) 
	session_start();

$controlvisita 		= 	new Controlvisita();

$idcontrolvisita	=	isset($_POST["idcontrolvisita"])? limpiarCadena($_POST["idcontrolvisita"]):"";
$idusuario			=	$_SESSION["idusuario"];
$num_controlvisita	=	isset($_POST["num_controlvisita"])? limpiarCadena($_POST["num_controlvisita"]):"";
$fecha_hora			=	isset($_POST["fecha_hora"])? limpiarCadena($_POST["fecha_hora"]):"";
$semana				=	isset($_POST["semana"])? limpiarCadena($_POST["semana"]):"";
$dia				=	isset($_POST["dia"])? limpiarCadena($_POST["dia"]):"";

//Actualizacion en grupo
$fechac			=	isset($_POST["fechac"])? limpiarCadena($_POST["fechac"]):"";

switch ($_GET["op"]) {
	case 'guardaryeditar':
		if (empty($idcontrolvisita)) {
			$rspta=$controlvisita->insertar($idusuario,$num_controlvisita,$fecha_hora,$semana,$dia,
			$_POST["cliente"],$_POST["fechavisita"],$_POST["personacontacto"],$_POST["telefono"],$_POST["observacion"]); 
			echo $rspta ? "Datos registrados correctamente" : "No se pudo registrar los datos";
		}else{
			$rspta=$controlvisita->actualizar($idcontrolvisita,$idusuario,$num_controlvisita,$fecha_hora,$semana,$dia,
			$_POST["cliente"],$_POST["fechavisita"],$_POST["personacontacto"],$_POST["telefono"],$_POST["observacion"]); 
			echo $rspta ? "Datos registrados correctamente" : "No se pudo registrar los datos";
		}
	break;

	case 'guardaryeditarm':
			$fecha_modificacion			= $_POST["fecha_modificacion"];
			$fechavisita				= $_POST["fechavisita"];
			$idcliente					= $_POST["idcliente"];
			$idvendedor					= $_POST["idvendedor"];
			$iddetalle_controlvisita 	= $_POST["iddetalle_controlvisita"];
		
			$rspta=$controlvisita->actualizarm($iddetalle_controlvisita,$idcontrolvisita,$idusuario,$idcliente,$idvendedor,$fechavisita,$fecha_modificacion); 
			echo $rspta ? "Datos registrados correctamente" : "No se pudo registrar los datos";
		
	break;

	case 'guardarfechacontroldevisitagrupo':
		
		$rspta=$controlvisita->guardarfechacontroldevisitagrupo($idcontrolvisita,$idusuario,$num_controlvisita,$fecha_hora,$semana,$dia,$fechac,
		$_POST["controlfechavalido"]); 
		echo $rspta ? "Datos registrados correctamente" : "No se pudo registrar los datos";
		
	break;

	case 'anular':
		$rspta=$controlvisita->anular($idcontrolvisita);
		echo $rspta ? "Ingreso anulado correctamente" : "No se pudo anular el ingreso";
	break;
	
	case 'mostrar':
		$rspta=$controlvisita->mostrar($idcontrolvisita);
		echo json_encode($rspta);
	break;

	case 'buscarNumeroControlvisita':
		$rspta=$controlvisita->buscarNumeroControlvisita();
		echo json_encode($rspta);
	break;

	case 'buscarSemanaControlvisita':
		$rspta=$controlvisita->buscarSemanaControlvisita($semana);
		echo json_encode($rspta);
	break;

	case 'verificarsemana':
		$rspta=$controlvisita->verificarsemana($semana);
		echo json_encode($rspta);
	break;
	
	case 'listarDetalle':
			//recibimos el idcontrolvisita
			$id=$_GET['id'];
	
			$rspta=$controlvisita->listarDetalle($id);
			$total=0;
			echo ' <thead style="background-color:#A9D0F5">
			<th>Articulo</th>
			<th>Cantidad</th>
			<th>Precio Venta</th>
			<th>Descuento</th>
			<th>Subtotal</th>
		   	</thead>';
			while ($reg=$rspta->fetch_object()) {
				echo '<tr class="filas">
				<td style="width:200px"><input type="hidden" name="idarticulo[]"  value="'.$reg->nombre.'">'.$reg->nombre.'</td>
				<td style="width:100px"><input type="text" name="cantidad[]" id="cantidad[]" style="text-align:right;width:100px" value="'.number_format($reg->cantidad,0,',','.').'"></td>
				<td style="width:160px"><input type="text" name="precio_venta[]" id="precio_venta[]" style="text-align:right;width:160px" value="'.number_format($reg->precio_venta,2,',','.').'"></td>
				<td style="width:160px"><input type="text" name="descuento[]" value="'.number_format($reg->descuento,2,',','.').'" style="text-align:right;width:160px"></td>
				<td style="width:160px;text-align:right"><span id="subtotal'.$cont.'" name="subtotal">'.number_format($reg->subtotal,2,',','.').'</span></td>';
				$cont=$cont+1;
				$total=$total+(($reg->precio_venta*$reg->cantidad)-$reg->descuento);
			}
			echo '<tfoot>
			 <th>TOTAL</th>
			 <th></th>
			 <th></th>
			 <th></th>
			 <th style="text-align:right"><h4 id="total"> '.number_format($total,2,',','.').' Bs.</h4>
			 <input type="hidden" name="total_venta" id="total_venta"></th>
		   </tfoot>';
	break;	
// se agrega la tarjeta en modulo de facturacion	
 	case 'agregarDetallePedidoDeBarra':
		//recibimos el idcontrolvisita
		$id			=	$_GET['id'];
		$cont		=	$_GET['cont']*1;
		$total		=	0;
		$rspta		=	$controlvisita->agregarDetallePedidoDeBarra($id);
		$porciento	=	0.1; //10% porciento
		//$cont	=200;
		while ($reg=$rspta->fetch_object()) {
			$preciodsiniva	=$reg->precio_venta-$reg->iva;
			$data			=array($cont,(($reg->iddetalle_pedido)*1),(($reg->idcontrolvisita)*1),(($reg->idarticulo)*1));
            echo '<tr class="filas" bgcolor="#F0F984" id="fila'.$cont.'">
			<td><button type="button" class="btn btn-danger" onclick="eliminarDetalleClave('.$cont.')">X</button></td>
			<td><input type="hidden" name="idarticulo[]" value="'.$reg->idarticulo.'">'.$reg->nombre.'</td>
			<td>'.$reg->num_tarjeta.'</td>
			<td>'.$reg->numerolote.' / '.$reg->fecha.'</td>
			<td><input type="text" name="cantidad[]" id="cantidad[]" style="text-align:right;width:80px" value="'.number_format($reg->cantidad,0,',','.').'" readonly></td>
			<td><input type="text" name="precio_venta[]" id="precio_venta[]" style="text-align:right;width:120px" value="'.number_format($reg->precio_venta,2,',','.').'" readonly></td>
			<td><input type="text" name="precio_ventad[]" id="precio_ventad[]" style="text-align:right;width:80px" value="'.number_format($reg->preciod,1,',','.').'" readonly></td>
			<td><input type="text" name="porcentaje[]" id="porcentaje[]" style="text-align:right;width:70px" value="'.number_format($reg->porcentaje,0,',','.').'" readonly></td>
			<td><input type="text" name="descuento[]" value="'.number_format($reg->descuento,2,',','.').'" style="text-align:right;width:120px" readonly></td>
			<td><input type="text" name="subtotal[]" id="subtotal[]" style="text-align:right;width:120px" value="'.number_format($reg->subtotal,2,',','.').'"></td>
			<td><button type="button" onclick="modificarSubtotales()" class="btn btn-info"><i class="fa fa-refresh"></i></button>
			<input type="hidden" name="idcontrolvisita[]" id="idcontrolvisita[]" value="'.json_encode($data).'">
			<input type="hidden" name="idpedidosolo[]" id="idpedidosolo[]" value="'.(($reg->idcontrolvisita)*1).'">
			<input type="hidden" name="idalmacen[]" id="idalmacen[]" value="'.$reg->idalmacen.'">
			<input type="hidden" name="precio_ventasiniva[]" id="precio_ventasiniva[]"  value="'.number_format($preciodsiniva,2,',','.').'"></input>
			<input type="hidden" name="exento[]" value="'.$reg->exento.'">
			<input type="hidden" name="nrolote[]" value="'.$reg->numerolote.'">
			<input type="hidden" name="articulo[]" id="articulo[]" value="'.$reg->nombre.'">
			<input type="hidden" name="iva[]" value="'.number_format($reg->iva,2,',','.').'">
			<input type="hidden" name="exentot[]" value="'.number_format($reg->mexento,2,',','.').'">	
			</td>
			</tr>';
			
			$total	=	$total+$reg->subtotal-$reg->iva;
			$cont	=	$cont+1;
		}
		$porciento	=	$total*$porciento;
		echo '<input type="hidden" name="porciento[]" id="porciento[]" value="'.$porciento.'">';
	break; 
	//agregarDetallePedidoDeBarra en la controlvisita
	case 'agregarDetallePorTarjeDeCliente':
		//recibimos el idcontrolvisita
		$id		=$_GET['id'];
		$cont	=$_GET['cont'];
		$rspta	=$controlvisita->agregarDetallePorTarjeDeCliente($id);
		$total	=0;
		//$cont	=200;
		
		while ($reg=$rspta->fetch_object()) {
			echo '<tr class="filas" bgcolor="#F0F984" id="fila'.$cont.'">
			<td><button type="button" class="btn btn-danger" onclick="eliminarDetalleClave('.$cont.')">X</button></td>
			<td><input type="hidden" name="idarticulo[]" value="'.$reg->idarticulo.'">'.$reg->nombre.'</td>
			<td><input type="text" name="cantidad[]" id="cantidad[]" style="text-align:right;width:100px" value="'.number_format($reg->cantidad,0,',','.').'" readonly></td>
			<td><input type="text" name="precio_venta[]" id="precio_venta[]" style="text-align:right;width:160px" value="'.number_format($reg->precio_venta,2,',','.').'" readonly></td>
			<td><input type="text" name="precio_ventad[]" id="precio_ventad[]" style="text-align:right;width:120px" value="'.number_format($reg->preciod,1,',','.').'" readonly></td>
			
			<td style="width:120px;text-align:right"><span id="subtotal'.$cont.'" name="subtotal">'.number_format($reg->subtotal,2,',','.').'</span></td>
			<td><button type="button" onclick="modificarSubtotales()" class="btn btn-info"><i class="fa fa-refresh"></i></button></td>
			<td style="visibility:hidden"><input type="hidden" name="idalmacen[]" id="idalmacen[]" value="'.$reg->idalmacen.'">
			<input type="hidden" name="idpedido1[]" id="idpedido1[]" value="'.$reg->idcontrolvisita.'">
			<input type="hidden" name="idpedidosolo[]" id="idpedidosolo[]" value="'.(($reg->idcontrolvisita)*1).'">
			<input type="hidden" name="idalmacen[]" id="idalmacen[]" value="'.$reg->idalmacen.'">
			<input type="hidden" name="nrolote[]" value="'.$reg->numerolote.'">
			<input type="hidden" name="articulo[]" id="articulo[]" value="'.$reg->nombre.'">
			<input type="hidden" name="iva[]" value="'.number_format($reg->iva,2,',','.').'">
			<input type="hidden" name="exentot[]" value="'.number_format($reg->exentot,2,',','.').'">
			<input type="hidden" name="porcentaje[]" id="porcentaje[]" value="'.number_format($reg->porcentaje,0,',','.').'" readonly>
			<input type="hidden" name="descuento[]" value="'.number_format($reg->descuento,2,',','.').'" readonly>	
				
			</td>
			
			</tr>';
			$cont=$cont+1;
		}
	break;
//c.idcontrolvisita, c.idcliente, c.idvendedor, u.nombre AS usuario, c.num_controlvisita, date_format(DATE(c.fecha_hora), '%d-%m-%Y') as fecha, c.semana, c.estado
    case 'listar':
		$rspta=$controlvisita->listar();
		$data=Array();
				
		while ($reg=$rspta->fetch_object()) {
			$estado='';
			if($reg->estado=='Pendiente'){
				$estado='<span class="badge bg-red">Iniciado</span>';
			}else{
				if($reg->estado=='Actualizado'){
					$estado='<span class="badge bg-yellow">Actualizado</span>';
				}else{
					if($reg->estado=='Anulado'){
						$estado='<span class="badge bg-purple">Anulado</span>';
					}else{
						$estado='<span class="badge bg-green">Finalizado</span>';
					}
				}	
			}
			$linea = '<a target="_blank" href="reportes/informecontroldevisita.php?id='.$reg->idcontrolvisita.'"><button class="btn btn-info btn-xs"><i class="fa fa-clone"></i></button></a>';

            $data[]=array(
			"0"=>(($reg->estado!='Anulado')?
			'<button class="btn btn-warning btn-xs" onclick="mostrar('.$reg->idcontrolvisita.')"><i class="fa fa-pencil"></i></button>
			'.' '.'<button class="btn btn-danger btn-xs" onclick="anular('.$reg->idcontrolvisita.')"><i class="fas fa-times"></i></button>'
			.' '.$linea
			:
			'<button class="btn btn-warning btn-xs" onclick="mostrarsolo('.$reg->idcontrolvisita.')"><i class="fa fa-eye"></i></button>'),
			"1"=>'<div align="center">'.$reg->fecha.'</div>',
            "2"=>'<div align="center">'.$reg->semana.'</div>',
			"3"=>'<div align="center">'.$reg->dia.'</div>',
			"4"=>'<div align="center">'.$reg->num_controlvisita.'</div>',
			"5"=>'<div align="left">'.$reg->usuario.'</div>',
            "6"=>'<div align="center">'.$estado.'</div>'
              );
		}
		$results=array(
             "sEcho"=>1,//info para datatables
             "iTotalRecords"=>count($data),//enviamos el total de registros al datatable
             "iTotalDisplayRecords"=>count($data),//enviamos el total de registros a visualizar
             "aaData"=>$data); 
		echo json_encode($results);
	break;

	case 'selectCliente':
		require_once "../modelos/Persona.php";
		$persona = new Persona();

		$rspta = $persona->listarc();

		while ($reg = $rspta->fetch_object()) {
			echo '<option value='.$reg->idpersona.'>'.$reg->nombre.'</option>';
		}
	break;

	case 'selectClienteTarjeta':
		require_once "../modelos/Persona.php";
		$persona = new Persona();

		$rspta = $persona->listarct();

		while ($reg = $rspta->fetch_object()) {
			echo '<option value='.$reg->idcontrolvisita.'>'.$reg->nombre.'</option>';
		}
	break;

	case 'listarArticulos':
		require_once "../modelos/Articulo.php";
		$articulo	=	new Articulo();
		$rspta		=	$articulo->listarActivosVentaBarra();
		$dataA		=	Array();
		$porcentaje	=	0;
		$iva		=	($_SESSION['iva_empresa']/100)+1;
		$tasa		=	($_SESSION['tasa_dollar_empresa']);
		$precio		= 	0;
		while ($reg=$rspta->fetch_object()) {
			$precio	= $reg->preciod*$tasa;
			if ($reg->exento=='si'){
				$precio = $precio;
			}
			$dataA[]=array(
						"0"=>'<button class="btn btn-warning" 
						onclick="agregarDetalle('.$reg->idarticulo.','.$reg->idalmacen.',\''.$reg->nombre.'\','.$precio.','.$reg->preciod.','.$reg->preciodsiniva.','.$porcentaje.',\''.$reg->exento.'\')"><span class="fa fa-plus"></span></button>',
						"1"=>$reg->nombre,
						"2"=>$reg->categoria,
						"3"=>$reg->codigo,
						"4"=>number_format($reg->stock,0,',','.'),
						"5"=>number_format($precio,2,',','.'),
						"6"=>number_format($reg->preciod,1,',','.'),
						"7"=>"<img src='files/articulos/".$reg->imagen."' height='50px' width='50px'>"
							);
		}
		$results=array(
						"sEcho"=>1,//info para datatables
						"iTotalRecords"=>count($dataA),//enviamos el total de registros al datatable
						"iTotalDisplayRecords"=>count($dataA),//enviamos el total de registros a visualizar
						"aaData"=>$dataA); 
		echo json_encode($results);

	break;

	case 'listarArticulosb':
		require_once "../modelos/Articulo.php";
		$articulo	=	new Articulo();
		$rspta		=	$articulo->listarActivosVenta();
		$dataA		=	Array();
		$porcentaje	=	0;
		$iva		=	($_SESSION['iva_empresa']/100)+1;
		$tasa		=	($_SESSION['tasa_dollar_empresa']);
		$precio		= 	0;
		while ($reg=$rspta->fetch_object()) {
			$precio	= $reg->preciod*$tasa;
			if ($reg->exento=='si'){
				$precio = $precio;
			}
			$dataA[]=array(
						"0"=>'<button class="btn btn-warning" 
						onclick="agregarDetalle('.$reg->idarticulo.','.$reg->idalmacen.',\''.$reg->nombre.'\','.$precio.','.$reg->preciod.','.$reg->preciodsiniva.','.$porcentaje.',\''.$reg->exento.'\')"><span class="fa fa-plus"></span></button>',
						"1"=>$reg->nombre,
						"2"=>$reg->categoria,
						"3"=>$reg->codigo,
						"4"=>number_format($reg->stock,0,',','.'),
						"5"=>number_format($precio,2,',','.'),
						"6"=>number_format($reg->preciod,1,',','.'),
						"7"=>"<img src='files/articulos/".$reg->imagen."' height='50px' width='50px'>"
							);
		}
		$results=array(
						"sEcho"=>1,//info para datatables
						"iTotalRecords"=>count($dataA),//enviamos el total de registros al datatable
						"iTotalDisplayRecords"=>count($dataA),//enviamos el total de registros a visualizar
						"aaData"=>$dataA); 
		echo json_encode($results);

	break;

	case 'listarPedidoDeBarra':
		$rspta=$controlvisita->listarPedidoDeBarra();
		$data=Array();
		while ($reg=$rspta->fetch_object()) {
			$data[]=array(
					"0"=>'<button class="btn btn-warning" 
					onclick="agregarDetallePedidoDeBarra('.$reg->idcontrolvisita.')">
					<span class="fa fa-plus"></span></button>',
					"1"=>$reg->tarjeta,
					"2"=>$reg->num_pedido,
					"3"=>number_format($reg->total_pedido,2,',','.'),
					"4"=>$reg->estado
					);
		}
		$results=array(
				"sEcho"=>1,//info para datatables
				"iTotalRecords"=>count($data),//enviamos el total de registros al datatable
				"iTotalDisplayRecords"=>count($data),//enviamos el total de registros a visualizar
				"aaData"=>$data); 
		echo json_encode($results);
	break;

	case 'listarDetalleclientevendedor':
		//recibimos el idventa
		$id=$_GET['id'];

		$rspta=$controlvisita->listarDetalleclientevendedor($id);
		$total=0;
			echo '<thead style="background-color:#A9D0F5">
			<th style="text-align:center">Fecha de Visita</th>
			<th style="text-align:center">Nro Control de Visita</th>
			<th style="text-align:center">Semana</th>
			
		</thead>
		<tbody>';
		$cont		=0; 
		$this1	='this';
		$deuda	=0;
		$totald	=0;
		while ($reg=$rspta->fetch_object()) {
			
			echo '<tr class="filas">
				
				<td style="text-align:center">
					
					<input type="text" style="text-align:center;border: inset 0pt;background-color:#ffffff" name="num_comprobante[]" value="'.$reg->fechavisita.'"  readonly>
					<button class="btn btn-warning btn-xs" onclick="actualizarfecham('.$reg->iddetalle_controlvisita.','.$reg->idcontrolvisita.','.$reg->idpersona.','.$reg->idvendedor.',\''.$reg->cliente.'\')"><i class="far fa-edit"></i></button>
					
				</td>
				<td style="text-align:center"><input type="text" style="text-align:center;border: inset 0pt;background-color:#ffffff" name="num_comprobantef[]" value="'.$reg->num_controlvisita.'"  readonly></td>
				<td style="text-align:center"><input type="text" style="text-align:center;border: inset 0pt;background-color:#ffffff" name="num_comprobantef1[]" value="'.$reg->semana.'"  readonly></td>
				
			</tr>';
			$cont+=1;	
		}
		
		echo '</tbody><tfoot>
			<tr>
			<th></th>
			<th></th>
			<th></th>
			
			</tr>
			
		</tfoot>';
	break;
}
 ?>